# Copyright 1999-2005 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $ 

inherit eutils

DESCRIPTION="nML is a dialect / harmony of Standard ML and OCaml."
HOMEPAGE="http://ropas.snu.ac.kr/n/"

MY_P="${P}b"
SRC_URI="http://ropas.snu.ac.kr/n/${MY_P}.tar.gz"
RESTRICT="nomirror test"

LICENSE="QPL"

SLOT="0"
KEYWORDS="-*"
IUSE="native ncurses threads"
DEPEND="ncurses? ( sys-libs/ncurses )"

src_unpack() {
	unpack "${MY_P}.tar.gz"
}

src_compile() {
	if use threads ; then
		threadconf="-with-pthread"
	else
		threadconf=""
	fi
	if use ncurses ; then
		ncursesconf=""
	else
		ncursesconf="-no-curses"
	fi
	./configure ${threadconf} ${ncursesconf} || die "could not configure"
	emake || die "emake failed"
	emake opt
	if use native ; then
		emake opt.opt
	fi
}

src_install() {
	export SANDBOX_ON=0
	umask 022
	make DESTDIR="${D}" install || die "make install failed"
	dodoc Changes INSTALL LICENSE README
}
