# Copyright 1999-2008 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-x86/dev-php5/ffmpeg-php/ffmpeg-php-0.6.0.ebuild,v 1.1 2008/12/11 20:30:31 ssuominen Exp $

PHP_EXT_NAME="cubrid"
PHP_EXT_INI="yes"
PHP_EXT_ZENDEXT="no"

inherit php-ext-source-r1

KEYWORDS="~amd64 ~x86"

DESCRIPTION="PHP extension for cubrid."
HOMEPAGE="http://www.cubrid.co.kr"
LICENSE="BSD"
SLOT="0"
DEPEND="dev-db/libcubrid"
RDEPEND="${DEPEND}"
IUSE=""

need_php_by_category

src_unpack() {
	cd ${WORKDIR}/../temp/
	rmdir ${WORKDIR}
	tar xzf ${FILESDIR}/cubrid-php-scm-2009-04-03.tar.gz || die
	mv cubrid-php-scm-2009-04-03/src ${WORKDIR}
	cd ${WORKDIR}
	perl -pi -e "s@\x24CUBRID/include@/usr/include/cubrid/include@g" config.m4
	if [ "${ARCH}" == "amd64" ]; then
		perl -pi -e "s@\x24CUBRID/lib64@/usr/lib64@g" config.m4
	else
		perl -pi -e "s@\x24CUBRID/lib64@/usr/lib@g" config.m4
	fi
	phpize
	rm aclocal.m4
	eautoreconf
}

src_install() {
	php-ext-source-r1_src_install
	php-ext-base-r1_addtoinifiles "cubrid.err_path" "/etc/php"

	insinto /etc/php
	insopts -m644
	doins ${FILESDIR}/cubrid_err.msg
}
