# Copyright 1999-2005 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit latex-package texlive-common

DESCRIPTION="ko.TeX is a collection of LaTeX packages made by Koaunghi Un,
Dohyun Kim and Kangsoo Kim to replace HLaTeX and Hangul-ucs.
See http://project.ktug.or.kr/ko.TeX/ for more information."

DEPEND="!dev-tex/hlatex
	!dev-tex/hangul-ucs
	!<=dev-tex/ko.tex-0.1.1
	!dev-tex/ko.tex-extra-texmf
	dev-tex/ko.tex-macro
	media-fonts/unfonts
	media-fonts/unfonts-extra
	 "
MY_P="ko.tex-extra-texmf-${PV}"
HOMEPAGE="http://faq.ktug.or.kr/ko.TeX"
SRC_URI=" http://ftp.ktug.or.kr/KTUG/ko.TeX/extrafonts/ko.tex-extra-hlfont.tar.gz
          http://ftp.ktug.or.kr/KTUG/ko.TeX/extrafonts/ko.tex-fonts-baekmuk-type1.tar.gz
		  http://ftp.ktug.or.kr/KTUG/ko.TeX/extrafonts/ko.tex-fonts-munhwa-t1.tar.gz
		  http://ftp.ktug.or.kr/KTUG/ko.TeX/extrafonts/ko.tex-fonts-trivcj-adobe.tar.gz
		  http://ftp.ktug.or.kr/KTUG/ko.TeX/extrafonts/ko.tex-fonts-unttf.tar.gz
		  http://ftp.ktug.or.kr/KTUG/ko.TeX/extrafonts/ko.tex-unfonts-extra.tar.gz" 

LICENSE="GPL-2"

SLOT="0"
KEYWORDS="x86 ppc alpha ~amd64 ppc-macos"
IUSE=""

src_unpack() {
	     mkdir ${S}
	     cd ${S}
	     for i in ${SRC_URI} ; do
	     	 bb=`basename $i`
		 unpack ${bb}
	done	
}

src_install() {
	insinto ${TEXMF_DIST_PATH}/
	doins -r tex
	doins -r fonts

	cd texmf-local
	doins -r tex
	
	insinto ${TEXMF_DIST_PATH}/fonts
    cd fonts
	doins -r map
	doins -r tfm
	doins -r truetype

}

pkg_postinst() {
	texhash
	updmap-sys --enable Map=kotex-extra.map 
}

pkg_postrm() {
	updmap-sys --enable Map=kotex-extra.map 
	texhash
}

