# Copyright 1999-2005 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

inherit latex-package texlive-common

DESCRIPTION="ko.TeX is a collection of LaTeX packages made by Koaunghi Un,
Dohyun Kim and Kangsoo Kim to replace HLaTeX and Hangul-ucs.
See http://project.ktug.or.kr/ko.TeX/ for more information."

DEPEND="!dev-tex/hlatex
	!dev-tex/hangul-ucs
	!<=dev-tex/ko.tex-0.1.1
	!dev-tex/ko.tex-bin
	!dev-tex/ko.tex-base-texmf
	!dev-tex/ko.tex-extra-texmf
	!dev-tex/ko.tex-bin
	 media-fonts/unfonts
	 media-fonts/unfonts-extra
	 app-text/texlive
	 "
MY_P="ko.tex-macro-${PV}"

HOMEPAGE="http://faq.ktug.or.kr/faq/Hangul-ucs"
SRC_URI=" http://ftp.ktug.or.kr/KTUG/ko.tex/current/${MY_P}.tar.gz
		  http://ftp.ktug.or.kr/KTUG/ko.tex/current/ko.tex-unfonts-base-20070927.tar.gz"

LICENSE="GPL-2"

SLOT="0"
KEYWORDS="x86 ppc alpha ~amd64 ppc-macos"
IUSE=""

src_unpack() {
	     mkdir ${S}
	     cd ${S}
	     for i in ${SRC_URI} ; do
	     	 bb=`basename $i`
		 unpack ${bb}
	done	
}
src_compile() {
	cd ${S}/util/
	gcc -o hmakeindex hmakeindex.c
	gcc -o hbibtex hbibtex.c
	rm *.c
	chmod a+x *.pl
	}	

	
src_install() {
	insinto ${TEXMF_DIST_PATH}/bibtex/bst/kotex/euc
	doins bibtex/euc/*

	insinto ${TEXMF_DIST_PATH}/tex/latex/kotex
	doins -r latex/*

	insinto ${TEXMF_DIST_PATH}/makeindex/kotex
	doins -r makeindex/*

	insinto ${TEXMF_DIST_PATH}/tex/plain/kotex
	doins plain/*

	insinto ${TEXMF_DIST_PATH}/fonts/sfd
	doins sfd/*

	insinto ${TEXMF_DIST_PATH}/
	doins -r tex
	doins -r fonts
	
	insinto /usr/share/doc/ko.tex
	doins -r doc

	insinto /usr/bin
	doins  util/*
		
}

pkg_postinst() {
	texhash
	updmap-sys --enable Map=kotex-base.map 
}

pkg_postrm() {
	updmap-sys --enable Map=kotex-base.map 
	texhash
}
