# Copyright 1999-2005 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2

inherit cvs latex-package

ECVS_AUTH="pserver"
ECVS_USER="anonymous"
ECVS_SERVER="cvs.savannah.gnu.org:/cvsroot/freetype"

DESCRIPTION="convert a TrueType font int TeX's PK format (from freetype1-contrib CVS Repository)"
HOMEPAGE="http://www.freetype.org/"
SRC_URI="http://www.freedesktop.org/~terry/hlatex/ttf2pk-1.5/01_ttf2pk-1.5-omega.patch
	http://www.freedesktop.org/~terry/hlatex/ttf2pk-1.5/02_ttf2pk-1.5-kpathsea.patch
	http://www.freedesktop.org/~terry/hlatex/ttf2pk-1.5/03_ttf2pk-1.5-freetype1.patch
	http://www.freedesktop.org/~terry/hlatex/ttf2pk-1.5/04_ttf2pk-1.5-freetype2.patch
	"
RESTRICT="nomirror"

LICENSE="FTL GPL-2"
SLOT="2"
KEYWORDS="alpha amd64 arm hppa ia64 mips ppc ppc64 ppc-macos s390 sh sparc x86"
IUSE=""

#DEPEND="hlatex
#	!=dev-tex/ttf2pk
#	"

DEPEND="dev-tex/hlatex"

S=${WORKDIR}/ttf2pk-1.5
src_unpack() {
#	ECVS_TOP_DIR="${DISTDIR}/cvs-src/${ECVS_MODULE}     
	mkdir ${S}
	cd ${S}
	ECVS_MODULE="freetype"
	cvs_src_unpack freetype
	ECVS_MODULE="freetype1-contrib"
	cvs_src_unpack freetype1-contrib

	cd ${S}/../freetype1-contrib/ttf2pk

patch -p0 < ${FILESDIR}/dvipdfmx_speed.patch
patch -p1 < ${DISTDIR}/01_ttf2pk-1.5-omega.patch
patch -p1 < ${DISTDIR}/02_ttf2pk-1.5-kpathsea.patch
patch -p1 < ${DISTDIR}/03_ttf2pk-1.5-freetype1.patch
patch -p1 < ${DISTDIR}/04_ttf2pk-1.5-freetype2.patch
	mv ${S}/../freetype1-contrib ${S}/../freetype/ 

	cd ${S}/../freetype/freetype1-contrib/ttf2pk

	ln -s /usr/include/freetype2/freetype freetype

	sed -e 's@^LIBTOOL .*@LIBTOOL = libtool@' \
        -e 's@^LIBDIR .*@LIBDIR = /usr/lib@' \
        -e 's@^MKINSTALLDIRS .*@MKINSTALLDIRS = $(srcdir)/mkinstalldirs@' \
        Makefile.in > tmp
	cp tmp Makefile.in

	sed -e 's/libttf/libfreetype/g' Makefile.in > tmp.1
	mv -f tmp.1 Makefile.in

	sed -e 's@^AC_CONFIG_SRCDIR.*@AC_CONFIG_SRCDIR([ttf2pk.c])@' \
	    -e 's@^CPPFLAGS=.*@CPPFLAGS="-I./freetype $CPPFLAGS"@' \
        configure.ac > tmp.3
	cp tmp.3 configure.ac

	sed -e 's@lttf@lfreetype@;s@(ttf@(freetype@;s@TT_Init_@FT_Init_@' \
       	configure.ac > tmp.1
	mv tmp.1 configure.ac



}

src_compile() {
	cd ${S}/../freetype
	sh ./configure
		make

	cd ${S}/../freetype/freetype1-contrib/ttf2pk

	sh ./configure --prefix=/usr --with-kpathsea-lib=/usr/lib \
     	--with-kpathsea-include=/usr/include/kpathsea
     	make
	gzip ttf2pk.1
	gzip ttf2tfm.1
}

src_install() {
	      insinto ${TEXMF}/ttf2pk
	      doins ../freetype/freetype1-contrib/ttf2pk/data/*.map
	      doins ../freetype/freetype1-contrib/ttf2pk/data/*.rpl
	      doins ../freetype/freetype1-contrib/ttf2pk/data/*.cfg
	      insinto ${TEXMF}/fonts/enc/ttf2pk
	      doins ../freetype/freetype1-contrib/ttf2pk/data/*.enc
	      insinto ${TEXMF}/fonts/sfd/ttf2pk
	      doins ../freetype/freetype1-contrib/ttf2pk/data/*.sfd

	      doman ../freetype/freetype1-contrib/ttf2pk/*.1.gz

	      dodoc ../freetype/freetype1-contrib/ttf2pk/README

	      dobin ../freetype/freetype1-contrib/ttf2pk/ttf2pk
	      dobin ../freetype/freetype1-contrib/ttf2pk/ttf2tfm

}
pkg_postinst() {
	       texhash
	       mktexlsr
}
pkg_postrm() {
	       texhash
	       mktexlsr
}
