# Copyright 1999-2009 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

EAPI="2"

MY_R=5212

DESCRIPTION="powerful media player front end."
HOMEPAGE="http://kldp.net/projects/cmplayer/"
SRC_URI="http://kldp.net/frs/download.php/${MY_R}/cmplayer-${PV}-src.tar.gz"
RESTRICT="nomirror"

LICENSE="GPL"
SLOT="0"
KEYWORDS="~x86 ~amd64"
IUSE="mplayer xine"

DEPEND=">=x11-libs/qt-core-4.4.0
	>=x11-libs/qt-gui-4.4.0
	mplayer? ( media-video/mplayer )
	xine? ( media-libs/xine-lib )"
RDEPEND="${DEPEND}"

src_unpack() {
	unpack ${A}
	cd ${WORK}
}

src_configure() {
	if use mplayer ; then
		export ENGINE_LIST="mplayer ${ENGINE_LIST}"
	fi
	if use xine ; then
		export ENGINE_LIST="xine ${ENGINE_LIST}"
	fi
	if "${ENGINE_LIST}x" == "x" ; then
		ewarn "You must choose USE mplayer or(and) xine"
		die
	fi
	export PREFIX=/usr/lib
	export CMPLAYER_BIN_PATH=/usr/bin
	export CMPLAYER_DATA_PATH=/usr/lib/cmplayer
	export CMPLAYER_TRANSLATION_PATH=/usr/lib/cmplayer/translations
	export CMPLAYER_LIB_PATH=/usr/lib
	export CMPLAYER_PLUGIN_PATH=/usr/lib
	export ENABLE_OPENGL=no
	export BUILD_PLUGIN_ONLY=no
}

src_compile() {
	emake
}

src_install() {
	dobin src/bin/cmplayer
	dolib src/bin/libcmplayer_*.so*
	insinto /usr/lib/cmplayer/translations
	doins src/cmplayer/translations/cmplayer_*.qm
	insinto /usr/share/applications
	doins cmplayer.desktop
	insinto /usr/share/pixmaps/cmplayer/icons/hicolor/16x16/apps
	cp icons/cmplayer16.png cmplayer.png
	doins cmplayer.png
	insinto /usr/share/pixmaps/cmplayer/icons/hicolor/22x22/apps
	cp icons/cmplayer22.png cmplayer.png
	doins cmplayer.png
	insinto /usr/share/pixmaps/cmplayer/icons/hicolor/32x32/apps
	cp icons/cmplayer32.png cmplayer.png
	doins cmplayer.png
	insinto /usr/share/pixmaps/cmplayer/icons/hicolor/48x48/apps
	cp icons/cmplayer48.png cmplayer.png
	doins cmplayer.png
	insinto /usr/share/pixmaps/cmplayer/icons/hicolor/64x64/apps
	cp icons/cmplayer64.png cmplayer.png
	doins cmplayer.png
	insinto /usr/share/pixmaps/cmplayer/icons/hicolor/128x128/apps
	cp icons/cmplayer128.png cmplayer.png
	doins cmplayer.png
}

pkg_postinst() {
	einfo "***************** CAUTION ******************"
	einfo "May you need remerge mplayer with LINGUAS=en"
	einfo "********************************************"
}
