# Copyright 1999-2007 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: $

# NOTICE: This package depend on kdelibs built with aRts
inherit cmake-utils kde

DESCRIPTION="Nateon for Linux"
HOMEPAGE="http://kldp.net/projects/nateon"
SRC_URI="amd64? ( http://nateondownload.nate.com/download/nateongen_64.zip )
	x86? ( http://nateondownload.nate.com/download/nateongen_32.zip )"

LICENSE="GPL-3"
KEYWORDS="~amd64 ~x86 ~ppc"

SLOT="0"
IUSE="+messagebox"

DEPEND="x11-libs/libX11
	x11-libs/libXext
	x11-libs/libXrender
	x11-libs/libXScrnSaver
	x11-misc/xdg-utils
	media-libs/libao
	<kde-base/kdelibs-4
	>=dev-db/sqlite-3.3.13
	>=dev-util/cmake-2.6.0
	!net-im/knateon
	!net-im/messagebox"

RDEPEND="${DEPEND}"

RESTRICT="mirror"

src_unpack() {
	cp ${FILESDIR}/${P}.tar.lzma ${WORKDIR}/ || die
	if [ "${ARCH}" = "amd64" ] ; then
		VER=64
	else
		VER=32
	fi
	unpack nateongen_${VER}.zip || die
	cd ${WORKDIR}
	unpack ./${P}.tar.lzma
}

src_compile() {
	if ! use messagebox ; then
		mycmakeargs="-DWITHOUT_MESSAGEBOX=ON"
	fi
	cmake-utils_src_compile
}

src_install() {
	cmake-utils_src_install
	cd ${WORKDIR}
	dobin nateongen
}
