# Copyright 1999-2007 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header$

inherit webapp eutils depend.php

DESCRIPTION="MoniWiki is a PHP based WikiEngine. WikiFormattingRules are imported and inspired from the MoinMoin."
HOMEPAGE="http://moniwiki.sourceforge.net"
SRC_URI="http://kldp.net/frs/download.php/3464/${P}.tgz"
RESTRICT="nomirror"
LICENSE="GPL-2"
KEYWORDS="~amd64 ~ppc ~sparc ~x86"
IUSE="rcs"

S="${WORKDIR}/${PN}"

RDEPEND="
		virtual/php
		net-www/apache
		rcs? ( app-text/rcs )"

need_php

pkg_setup() {
	webapp_pkg_setup
	require_php_with_use pcre
}

src_unpack() {
	unpack ${A}
	cd ${S}
	rm Makefile
	rm moni-install.in
}

src_install() {
	webapp_src_preinst

	dodoc INSTALL COPYING README THANKS

	insinto ${MY_HTDOCSDIR}
	doins *.php *.html *.sh	config.php.default

	cp -Rpf ${S}/* ${D}/${MY_HTDOCSDIR}

#	for DIR in ${DIRS[*]}; do
#		dodir ${MY_HTDOCSDIR}/${DIR}
#		insinto ${MY_HTDOCSDIR}/${DIR}
#		doins ${DIR}/*
#		test -f ${DIR}/.htaccess && doins ${DIR}/.htaccess
#	done

#	for DIR in ${THEMES[*]}; do
#		dodir ${MY_HTDOCSDIR}/${DIR}
#		insinto ${MY_HTDOCSDIR}/${DIR}
#		doins ${DIR}/*
#		test -f ${DIR}/.htaccess && doins ${DIR}/.htaccess
#	done

	webapp_serverowned ${MY_HTDOCSDIR}
	webapp_serverowned ${MY_HTDOCSDIR}/data
#	webapp_serverowned ${D}${P}/pds
	webapp_src_install
}

pkg_postinst() {
	elog
	elog "for further installation sequence, "
	elog "Open http://HOST.DOMAIN.NAME/moniwiki/monisetup.php with your webbrowser."
	elog
}
